/*
 * This file is part of Espruino, a JavaScript interpreter for Microcontrollers
 *
 * Copyright (C) 2013 Gordon Williams <gw@pur3.co.uk>
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * ----------------------------------------------------------------------------
 * JavaScript methods and functions for the interactive shell
 * ----------------------------------------------------------------------------
 */
#ifndef JSWRAP_INTERACTIVE_H_
#define JSWRAP_INTERACTIVE_H_

#include "jsvar.h"
#include "jsinteractive.h"
#include "jsflash.h"

void jswrap_interface_setBusyIndicator(JsVar *pinVar);
void jswrap_interface_setSleepIndicator(JsVar *pinVar);
void jswrap_interface_setDeepSleep(bool sleep);
void jswrap_interface_load(JsVar *storageName);
void jswrap_interface_reset(bool clearFlash);
void jswrap_interface_edit(JsVar *funcName);
void jswrap_interface_echo(bool echoOn);
void jswrap_interactive_setTime(JsVarFloat time);
JsVar *jswrap_interface_getSerial();

JsVar *jswrap_interface_setInterval(JsVar *func, JsVarFloat timeout, JsVar *args);
JsVar *jswrap_interface_setTimeout(JsVar *func, JsVarFloat timeout, JsVar *args);
// also see jsiSetTimeout for native implementation
void jswrap_interface_clearInterval(JsVar *idVarArr);
void jswrap_interface_clearTimeout(JsVar *idVarArr);
void jswrap_interface_changeInterval(JsVar *idVar, JsVarFloat interval);

#endif // JSWRAP_INTERACTIVE_H_
