/*
 * This file is part of Espruino, a JavaScript interpreter for Microcontrollers
 *
 * Copyright (C) 2013 Gordon Williams <gw@pur3.co.uk>
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * ----------------------------------------------------------------------------
 * JavaScript Pin Object Functions
 * ----------------------------------------------------------------------------
 */
#ifndef JSWRAP_PIN_H_
#define JSWRAP_PIN_H_

#include "jsvar.h"
#include "jsinteractive.h"

JsVar *jswrap_pin_constructor(JsVar *val);
bool jswrap_pin_read(JsVar *parent);
void jswrap_pin_set(JsVar *parent);
void jswrap_pin_reset(JsVar *parent);
void jswrap_pin_write(JsVar *parent, bool value);
void jswrap_pin_writeAtTime(JsVar *parent, bool value, JsVarFloat time);
JsVar *jswrap_pin_getMode(JsVar *parent);
void jswrap_pin_mode(JsVar *parent, JsVar *mode);
bool jswrap_pin_toggle(JsVar *parent);
void jswrap_pin_pulse(JsVar *parent, bool value, JsVar *times);
JsVarFloat jswrap_pin_analog(JsVar *parent);
void jswrap_pin_pwm(JsVar *parent, JsVarFloat value, JsVar *options);
JsVar *jswrap_pin_getInfo(JsVar *parent);

#endif // JSWRAP_PIN_H_
