/*
 * This file is part of Espruino, a JavaScript interpreter for Microcontrollers
 *
 * Copyright (C) 2014 Gordon Williams <gw@pur3.co.uk>
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * ----------------------------------------------------------------------------
 * This file is designed to be parsed during the build process
 *
 * Nucleo-specific pin namings
 * ----------------------------------------------------------------------------
 */

#include "jswrap_nucleo.h"

/*JSON{
  "type" : "class",
  "class" : "Nucleo"
}
This is the built-in class for the Arduino-style pin namings on ST Nucleo boards
*/

/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "A0",  "generate_full" : "NUCLEO_A0",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "A1",  "generate_full" : "NUCLEO_A1",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "A2",  "generate_full" : "NUCLEO_A2",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "A3",  "generate_full" : "NUCLEO_A3",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "A4",  "generate_full" : "NUCLEO_A4",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "A5",  "generate_full" : "NUCLEO_A5",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D0",  "generate_full" : "NUCLEO_D0",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D1",  "generate_full" : "NUCLEO_D1",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D2",  "generate_full" : "NUCLEO_D2",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D3",  "generate_full" : "NUCLEO_D3",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D4",  "generate_full" : "NUCLEO_D4",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D5",  "generate_full" : "NUCLEO_D5",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D6",  "generate_full" : "NUCLEO_D6",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D7",  "generate_full" : "NUCLEO_D7",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D8",  "generate_full" : "NUCLEO_D8",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D9",  "generate_full" : "NUCLEO_D9",  "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D10", "generate_full" : "NUCLEO_D10", "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D11", "generate_full" : "NUCLEO_D11", "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D12", "generate_full" : "NUCLEO_D12", "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D13", "generate_full" : "NUCLEO_D13", "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D14", "generate_full" : "NUCLEO_D14", "return" : ["pin","A Pin"]
}*/
/*JSON{"type" : "staticproperty","class" : "Nucleo","name" : "D15", "generate_full" : "NUCLEO_D15", "return" : ["pin","A Pin"]
}*/

